/* logjam - a GTK client for LiveJournal.
 * Copyright (C) 2000-2003 Evan Martin <evan@livejournal.com>
 * Ported to LogJam by Ari Pollak <ari@debian.org>
 * 
 * This file is based on gedit-undo-manager.h from gEdit 2.2.1.
 * Original authors:
 * Copyright (C) 1998, 1999 Alex Roberts, Evan Lawrence
 * Copyright (C) 2000, 2001 Chema Celorio, Paolo Maggi 
 */

#ifndef __UNDO_MANAGER_H__
#define __UNDO_MANAGER_H__

#define TYPE_UNDO_MANAGER				(undo_manager_get_type ())
#define UNDO_MANAGER(obj)				(GTK_CHECK_CAST ((obj), TYPE_UNDO_MANAGER, UndoManager))
#define UNDO_MANAGER_CLASS(klass)		(GTK_CHECK_CLASS_CAST ((klass), TYPE_UNDO_MANAGER, UndoManagerClass))
#define IS_UNDO_MANAGER(obj)			(GTK_CHECK_TYPE ((obj), TYPE_UNDO_MANAGER))
#define IS_UNDO_MANAGER_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_MANAGER))
#define UNDO_MANAGER_GET_CLASS(obj)		(GTK_CHECK_GET_CLASS ((obj), TYPE_UNDO_MANAGER, UndoManagerClass))


typedef struct _UndoManagerPrivate		UndoManagerPrivate;

typedef struct 
{
	GObject base;
	
	UndoManagerPrivate *priv;
} UndoManager;

typedef struct
{
	GObjectClass parent_class;

	/* Signals */
	void (*can_undo)( UndoManager *um, gboolean can_undo);
   	void (*can_redo)( UndoManager *um, gboolean can_redo);
} UndoManagerClass;

GType        	undo_manager_get_type	(void) G_GNUC_CONST;

UndoManager*	undo_manager_new		(void);
void			undo_manager_attach		(UndoManager *um, GtkWidget *widget);
void			undo_manager_detach		(UndoManager *um, GtkWidget *widget);

/* Clears the stack of undo actions: */
void			undo_manager_reset		(UndoManager *um);

gboolean		undo_manager_can_undo	(const UndoManager *um);
gboolean		undo_manager_can_redo 	(const UndoManager *um);

void			undo_manager_undo 	(UndoManager *um);
void			undo_manager_redo 	(UndoManager *um);

void	undo_manager_begin_not_undoable_action 	(UndoManager *um);
void	undo_manager_end_not_undoable_action 	(UndoManager *um);

#endif /* __UNDO_MANAGER_H__ */
